#!/bin/bash
#

#source /etc/profile
# /etc/init.d/diskopt.sh
#
### BEGIN INIT INFO
# Provides:			diskopt_script
# Required-Start:		$network
# X-UnitedLinux-Should-Start:	
# Required-Stop:		
# X-UnitedLinux-Should-Stop:	
# Default-Start:		3 5
# Default-Stop:			0 1 2 6
# Short-Description:		Custom disk optimization script
# Description:			Custom disk optimization script
### END INIT INFO

test -s /etc/rc.status && . /etc/rc.status && rc_reset

case "$1" in
	start)
	

echo "Optimizing RAID Arrays..."


# This step must come first.
# See: http://www.3ware.com/KB/article.aspx?id=11050

echo "Setting max_sectors_kb to chunk size of RAID5 arrays..."
for i in sda sdb sdc sdd sde sdf sdg sdh sdi sdj sdk
do
echo "Setting /dev/$i to 128K..."
echo 128 > /sys/block/"$i"/queue/max_sectors_kb
done

echo "Setting read-ahead to 64MB for /dev/md[10]"
blockdev --setra 65536 /dev/md0
blockdev --setra 65536 /dev/md1

echo "Setting stripe_cache_size to 16MB for /dev/md[10]"
echo 16384	> /sys/block/md0/md/stripe_cache_size
echo 16384 	> /sys/block/md1/md/stripe_cache_size

# if you use more than the default 64kb stripe with raid5
# this feature is broken so you need to limit it to 30MB/s
# neil has a patch, not sure when it will be merged.
echo "Setting minimum and maximum resync speed to 30MB/s..."
echo 30000 > /sys/block/md0/md/sync_speed_min
echo 30000 > /sys/block/md0/md/sync_speed_max
echo 30000 > /sys/block/md1/md/sync_speed_min
echo 30000 > /sys/block/md1/md/sync_speed_max


# Disable NCQ.
echo "Disabling NCQ..."
for i in sda sdb sdc sdd sde sdf sdg sdh sdi sdj sdk
do
echo "Disabling NCQ on $i"
echo 1 > /sys/block/"$i"/device/queue_depth
done

	;;
	stop)
	# skip or put your own commands here
	;;
esac

rc_exit
